<?php

	global $aIdealCheckout;

	// Load database settings
	require_once(dirname(__FILE__) . '/includes/init.php');



	$aQueries = array();

	// Add idealcheckout table
	$aQueries[] = "CREATE TABLE IF NOT EXISTS `" . $aIdealCheckout['database']['table'] . "` (
`id` int(8) UNSIGNED NOT NULL AUTO_INCREMENT, 
`order_id` VARCHAR(64) DEFAULT NULL, 
`order_code` VARCHAR(64) DEFAULT NULL, 
`order_params` TEXT DEFAULT NULL, 
`store_code` VARCHAR(64) DEFAULT NULL, 
`gateway_code` VARCHAR(64) DEFAULT NULL, 
`language_code` VARCHAR(2) DEFAULT NULL, 
`country_code` VARCHAR(2) DEFAULT NULL, 
`currency_code` VARCHAR(3) DEFAULT NULL, 
`transaction_id` VARCHAR(64) DEFAULT NULL, 
`transaction_code` VARCHAR(64) DEFAULT NULL, 
`transaction_params` TEXT DEFAULT NULL, 
`transaction_date` INT(11) UNSIGNED DEFAULT NULL, 
`transaction_amount` DECIMAL(10, 2) UNSIGNED DEFAULT NULL, 
`transaction_description` VARCHAR(100) DEFAULT NULL, 
`transaction_status` VARCHAR(16) DEFAULT NULL, 
`transaction_url` VARCHAR(255) DEFAULT NULL, 
`transaction_payment_url` VARCHAR(255) DEFAULT NULL, 
`transaction_success_url` VARCHAR(255) DEFAULT NULL, 
`transaction_pending_url` VARCHAR(255) DEFAULT NULL, 
`transaction_failure_url` VARCHAR(255) DEFAULT NULL, 
`transaction_log` TEXT DEFAULT NULL, 
PRIMARY KEY (`id`));";


	// Add default labels for iDEAL status
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('100', '1', 'Payment success (verified)')";
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('101', '1', 'Payment success')";
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('102', '1', 'Payment pending')";
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('103', '1', 'Payment open')";
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('104', '1', 'Payment canceled')";
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('105', '1', 'Payment failure')";
	$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('106', '1', 'Payment expired')";

	$sql = "SELECT `language_id` FROM `" . $aIdealCheckout['database']['prefix'] . "aceshop_language` WHERE `code` = 'nl' LIMIT 1;";
	$oRecordset = idealcheckout_database_query($sql) or idealcheckout_die('QUERY: ' . $sql . ', ERROR: ' . idealcheckout_database_error(), __FILE__, __LINE__);

	if(idealcheckout_database_num_rows($oRecordset))
	{
		$oRecord = idealcheckout_database_fetch_assoc($oRecordset);

		if(strcmp($oRecord['language_id'], '1') !== 0)
		{
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('100', '" . $oRecord['language_id'] . "', 'Betaling ontvangen (gecontroleerd)')";
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('101', '" . $oRecord['language_id'] . "', 'Betaling ontvangen')";
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('102', '" . $oRecord['language_id'] . "', 'Betaling in behandeling')";
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('103', '" . $oRecord['language_id'] . "', 'Betaling open')";
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('104', '" . $oRecord['language_id'] . "', 'Betaling geannuleerd')";
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('105', '" . $oRecord['language_id'] . "', 'Betaling mislukte')";
			$aQueries[] = "INSERT INTO `" . $aIdealCheckout['database']['prefix'] . "aceshop_order_status` (`order_status_id`, `language_id`, `name`) VALUES ('106', '" . $oRecord['language_id'] . "', 'Betaling verlopen')";
		}
	}




	$query_html = '';
	
	for($i = 0; $i < sizeof($aQueries); $i++)
	{
		if(idealcheckout_database_query($aQueries[$i]))
		{
			// Query success
		}
		else
		{
			$query_html .= '<b>Query:</b> ' . $aQueries[$i] . '<br><b>Error:</b> ' . idealcheckout_database_error() . '<br><br><br>';
		}
	}


	// Validate files & directories
	$sBasePath = dirname(__FILE__);

	$aPaths = array();

	// Gateway files
	$aPaths[] = array('path' => $sBasePath . '/certificates', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/configuration', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/gateways', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/gateways/gateway.core.cls.4.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/gateways/gateway.core.cls.5.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/images', 'write' => false);

	$aPaths[] = array('path' => $sBasePath . '/temp', 'write' => true);
	$aPaths[] = array('path' => $sBasePath . '/.htaccess', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/includes/init.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/index.html', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/report.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/return.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/setup.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/transaction.php', 'write' => false);
	$aPaths[] = array('path' => $sBasePath . '/validate.php', 'write' => false);


	$files_html = '';

	for($i = 0; $i < sizeof($aPaths); $i++)
	{
		if(is_file($aPaths[$i]['path']))
		{
			if($aPaths[$i]['write'] && !is_writable($aPaths[$i]['path']))
			{
				$files_html .= 'File <b>' . $aPaths[$i]['path'] . '</b> not writable.<br>';
			}
		}
		elseif(is_dir($aPaths[$i]['path']))
		{
			if($aPaths[$i]['write'] && !is_writable($aPaths[$i]['path']))
			{
				$files_html .= 'Directory <b>' . $aPaths[$i]['path'] . '</b> not writable.<br>';
			}
		}
		else
		{
			$files_html .= 'File <b>' . $aPaths[$i]['path'] . '</b> does not exist.<br>';
		}
	}


	echo '
<h1>INSTALL LOG</h1>
<p style="color: red;">Please remove this file (FTP: /idealcheckout/install.php) after installation!</p>

<p>&nbsp;</p>

<h3>Queries:</h3>
<code>' . ($query_html ? $query_html : 'No warnings found') . '</code>

<p>&nbsp;</p>

<h3>Files &amp; Folders:</h3>
<code>' . ($files_html ? $files_html : 'No warnings found') . '</code>

<h3>Server checks:</h3>
<code>PHP Version: ' . PHP_VERSION . '<br>OPENSSL Library: ' . (function_exists('openssl_sign') ? 'Installed' : 'Not installed') . '<br>FSOCK Library: ' . (function_exists('fsockopen') ? 'Installed' : 'Not installed') . '<br>CURL Library: ' . (function_exists('curl_init') ? 'Installed' : 'Not installed') . '</code>';

?>